commit 9a23dff4f8eb92150074223098af30ea91a4d3da
Author: Gaius Mulley <gaiusmod2@gmail.com>
Date:   Wed Nov 20 00:17:23 2024 +0000

    [PATCH] modula2: use groups in the type resolver of the bootstrap tool mc
    
    This patch introduces groups to maintain the lists used when resolving
    types in the bootstrap tool mc.  The groups and type resolver are very
    similar to that used in cc1gm2.  Specifically the resolver uses the group
    to detect any change to any element in any list within a group.  This is
    much cleaner and safer than the previous list length comparisons.
    
    gcc/m2/ChangeLog:
    
            * Make-lang.in (MC_EXTENDED_OPAQUE): New definition.
            * mc-boot/GDynamicStrings.cc: Rebuild.
            * mc-boot/GDynamicStrings.h: Rebuild.
            * mc-boot/Galists.cc: Rebuild.
            * mc-boot/Galists.h: Rebuild.
            * mc-boot/Gdecl.cc: Rebuild.
            * mc/alists.def (equalList): New procedure.
            * mc/alists.mod (equalList): New procedure implementation.
            * mc/decl.mod (group): New type.
            (freeGroup): New variable.
            (globalGroup): Ditto.
            (todoQ): Remove declaration and prefix all occurances with globalGroup^.
            (partialQ): Ditto.
            (doneQ): Ditto.
            (newGroup): New procedure.
            (initGroup): Ditto.
            (killGroup): Ditto.
            (dupGroup): Ditto.
            (equalGroup): Ditto.
            (topologicallyOut): Rewrite.
    
    (cherry picked from commit 20e6f36771df7e3a8857628dd367eecfe77ba4fc)
    
    Signed-off-by: Gaius Mulley <gaiusmod2@gmail.com>

diff --git a/gcc/m2/Make-lang.in b/gcc/m2/Make-lang.in
index da4226123df..83d592f35d8 100644
--- a/gcc/m2/Make-lang.in
+++ b/gcc/m2/Make-lang.in
@@ -505,6 +505,7 @@ MC_ARGS= --olang=c++ \
  $(MC_COPYRIGHT) \
  --gcc-config-system
 
+MC_EXTENDED_OPAQUE=--extended-opaque
 MCDEPS=m2/boot-bin/mc$(exeext)
 
 MC=m2/boot-bin/mc$(exeext) $(MC_ARGS)
@@ -1539,7 +1540,7 @@ m2/gm2-libs-boot/SysStorage.o: $(srcdir)/m2/gm2-libs/SysStorage.mod $(MCDEPS) $(
 
 m2/gm2-compiler-boot/M2GCCDeclare.o: $(srcdir)/m2/gm2-compiler/M2GCCDeclare.mod $(MCDEPS) $(BUILD-BOOT-H)
 	-test -d $(@D)/$(DEPDIR) || $(mkinstalldirs) $(@D)/$(DEPDIR)
-	$(MC) --extended-opaque -o=m2/gm2-compiler-boot/M2GCCDeclare.c $<
+	$(MC) $(MC_EXTENDED_OPAQUE) -o=m2/gm2-compiler-boot/M2GCCDeclare.c $<
 	$(COMPILER) $(CM2DEP) -c $(ALL_COMPILERFLAGS) $(ALL_CPPFLAGS) $(GM2GCC) \
             -I. -I$(srcdir)/../include -I$(srcdir) \
             -I. -Im2/gm2-libs-boot -Im2/gm2-compiler-boot \
@@ -1548,7 +1549,7 @@ m2/gm2-compiler-boot/M2GCCDeclare.o: $(srcdir)/m2/gm2-compiler/M2GCCDeclare.mod
 
 m2/gm2-compiler-boot/M2Error.o: $(srcdir)/m2/gm2-compiler/M2Error.mod $(MCDEPS) $(BUILD-BOOT-H)
 	-test -d $(@D)/$(DEPDIR) || $(mkinstalldirs) $(@D)/$(DEPDIR)
-	$(MC) --extended-opaque -o=m2/gm2-compiler-boot/M2Error.c $<
+	$(MC) $(MC_EXTENDED_OPAQUE) -o=m2/gm2-compiler-boot/M2Error.c $<
 	$(COMPILER) $(CM2DEP) -c $(ALL_COMPILERFLAGS) $(ALL_CPPFLAGS) $(GM2GCC) \
             -I. -I$(srcdir)/../include -I$(srcdir) \
             -I. -Im2/gm2-libs-boot -Im2/gm2-compiler-boot \
diff --git a/gcc/m2/mc-boot/GDynamicStrings.cc b/gcc/m2/mc-boot/GDynamicStrings.cc
index 7f61778af64..a1cb88c03b7 100644
--- a/gcc/m2/mc-boot/GDynamicStrings.cc
+++ b/gcc/m2/mc-boot/GDynamicStrings.cc
@@ -255,12 +255,25 @@ extern "C" int DynamicStrings_Index (DynamicStrings_String s, char ch, unsigned
 
 /*
    RIndex - returns the indice of the last occurance of, ch,
-            in String, s. The search starts at position, o.
-            -1 is returned if, ch, is not found.
+            in String, s.  The search starts at position, o.
+            -1 is returned if, ch, is not found.  The search
+            is performed left to right.
 */
 
 extern "C" int DynamicStrings_RIndex (DynamicStrings_String s, char ch, unsigned int o);
 
+/*
+   ReverseIndex - returns the indice of the last occurance of ch
+                  in String s.  The search starts at position o
+                  and searches from right to left.  The start position
+                  may be indexed negatively from the right (-1 is the
+                  last index).
+                  The return value if ch is found will always be positive.
+                  -1 is returned if ch is not found.
+*/
+
+extern "C" int DynamicStrings_ReverseIndex (DynamicStrings_String s, char ch, int o);
+
 /*
    RemoveComment - assuming that, comment, is a comment delimiter
                    which indicates anything to its right is a comment
@@ -2177,8 +2190,9 @@ extern "C" int DynamicStrings_Index (DynamicStrings_String s, char ch, unsigned
 
 /*
    RIndex - returns the indice of the last occurance of, ch,
-            in String, s. The search starts at position, o.
-            -1 is returned if, ch, is not found.
+            in String, s.  The search starts at position, o.
+            -1 is returned if, ch, is not found.  The search
+            is performed left to right.
 */
 
 extern "C" int DynamicStrings_RIndex (DynamicStrings_String s, char ch, unsigned int o)
@@ -2227,6 +2241,52 @@ extern "C" int DynamicStrings_RIndex (DynamicStrings_String s, char ch, unsigned
 }
 
 
+/*
+   ReverseIndex - returns the indice of the last occurance of ch
+                  in String s.  The search starts at position o
+                  and searches from right to left.  The start position
+                  may be indexed negatively from the right (-1 is the
+                  last index).
+                  The return value if ch is found will always be positive.
+                  -1 is returned if ch is not found.
+*/
+
+extern "C" int DynamicStrings_ReverseIndex (DynamicStrings_String s, char ch, int o)
+{
+  unsigned int c;
+
+  if (PoisonOn)
+    {
+      s = CheckPoisoned (s);
+    }
+  if (o < 0)
+    {
+      o = ((int ) (DynamicStrings_Length (s)))+o;
+      if (o < 0)
+        {
+          return -1;
+        }
+    }
+  if (((unsigned int ) (o)) < (DynamicStrings_Length (s)))
+    {
+      while (o >= 0)
+        {
+          if ((DynamicStrings_char (s, o)) == ch)
+            {
+              return o;
+            }
+          else
+            {
+              o -= 1;
+            }
+        }
+    }
+  return -1;
+  /* static analysis guarentees a RETURN statement will be used before here.  */
+  __builtin_unreachable ();
+}
+
+
 /*
    RemoveComment - assuming that, comment, is a comment delimiter
                    which indicates anything to its right is a comment
@@ -2251,7 +2311,7 @@ extern "C" DynamicStrings_String DynamicStrings_RemoveComment (DynamicStrings_St
     }
   if (TraceOn)
     {
-      s = AssignDebug (s, (const char *) "../../gcc/m2/gm2-libs/DynamicStrings.mod", 40, 1534, (const char *) "RemoveComment", 13);
+      s = AssignDebug (s, (const char *) "../../gcc/m2/gm2-libs/DynamicStrings.mod", 40, 1576, (const char *) "RemoveComment", 13);
     }
   return s;
   /* static analysis guarentees a RETURN statement will be used before here.  */
@@ -2276,7 +2336,7 @@ extern "C" DynamicStrings_String DynamicStrings_RemoveWhitePrefix (DynamicString
   s = DynamicStrings_Slice (s, (int ) (i), 0);
   if (TraceOn)
     {
-      s = AssignDebug (s, (const char *) "../../gcc/m2/gm2-libs/DynamicStrings.mod", 40, 1646, (const char *) "RemoveWhitePrefix", 17);
+      s = AssignDebug (s, (const char *) "../../gcc/m2/gm2-libs/DynamicStrings.mod", 40, 1688, (const char *) "RemoveWhitePrefix", 17);
     }
   return s;
   /* static analysis guarentees a RETURN statement will be used before here.  */
@@ -2301,7 +2361,7 @@ extern "C" DynamicStrings_String DynamicStrings_RemoveWhitePostfix (DynamicStrin
   s = DynamicStrings_Slice (s, 0, i+1);
   if (TraceOn)
     {
-      s = AssignDebug (s, (const char *) "../../gcc/m2/gm2-libs/DynamicStrings.mod", 40, 1668, (const char *) "RemoveWhitePostfix", 18);
+      s = AssignDebug (s, (const char *) "../../gcc/m2/gm2-libs/DynamicStrings.mod", 40, 1710, (const char *) "RemoveWhitePostfix", 18);
     }
   return s;
   /* static analysis guarentees a RETURN statement will be used before here.  */
diff --git a/gcc/m2/mc-boot/GDynamicStrings.h b/gcc/m2/mc-boot/GDynamicStrings.h
index 76f4cea6c81..e0652a7d3bd 100644
--- a/gcc/m2/mc-boot/GDynamicStrings.h
+++ b/gcc/m2/mc-boot/GDynamicStrings.h
@@ -194,12 +194,25 @@ EXTERN int DynamicStrings_Index (DynamicStrings_String s, char ch, unsigned int
 
 /*
    RIndex - returns the indice of the last occurance of, ch,
-            in String, s. The search starts at position, o.
-            -1 is returned if, ch, is not found.
+            in String, s.  The search starts at position, o.
+            -1 is returned if ch is not found.  The search
+            is performed left to right.
 */
 
 EXTERN int DynamicStrings_RIndex (DynamicStrings_String s, char ch, unsigned int o);
 
+/*
+   ReverseIndex - returns the indice of the last occurance of ch
+                  in String s.  The search starts at position o
+                  and searches from right to left.  The start position
+                  may be indexed negatively from the right (-1 is the
+                  last index).
+                  The return value if ch is found will always be positive.
+                  -1 is returned if ch is not found.
+*/
+
+EXTERN int DynamicStrings_ReverseIndex (DynamicStrings_String s, char ch, int o);
+
 /*
    RemoveComment - assuming that, comment, is a comment delimiter
                    which indicates anything to its right is a comment
diff --git a/gcc/m2/mc-boot/Galists.cc b/gcc/m2/mc-boot/Galists.cc
index 2505ab13361..238bcc87d50 100644
--- a/gcc/m2/mc-boot/Galists.cc
+++ b/gcc/m2/mc-boot/Galists.cc
@@ -137,6 +137,12 @@ extern "C" void alists_foreachItemInListDo (alists_alist l, alists_performOperat
 
 extern "C" alists_alist alists_duplicateList (alists_alist l);
 
+/*
+   equalList - returns TRUE if left contains the same information as right.
+*/
+
+extern "C" bool alists_equalList (alists_alist left, alists_alist right);
+
 /*
    removeItem - remove an element at index, i, from the alist data type.
 */
@@ -432,6 +438,43 @@ extern "C" alists_alist alists_duplicateList (alists_alist l)
   __builtin_unreachable ();
 }
 
+
+/*
+   equalList - returns TRUE if left contains the same information as right.
+*/
+
+extern "C" bool alists_equalList (alists_alist left, alists_alist right)
+{
+  unsigned int leftn;
+  unsigned int rightn;
+  unsigned int i;
+
+  leftn = alists_noOfItemsInList (left);
+  rightn = alists_noOfItemsInList (right);
+  if (leftn == rightn)
+    {
+      i = 1;
+      while (i <= leftn)
+        {
+          if (alists_isItemInList (right, alists_getItemFromList (left, i)))
+            {
+              i += 1;
+            }
+          else
+            {
+              return false;
+            }
+        }
+    }
+  else
+    {
+      return false;
+    }
+  return true;
+  /* static analysis guarentees a RETURN statement will be used before here.  */
+  __builtin_unreachable ();
+}
+
 extern "C" void _M2_alists_init (__attribute__((unused)) int argc,__attribute__((unused)) char *argv[],__attribute__((unused)) char *envp[])
 {
 }
diff --git a/gcc/m2/mc-boot/Galists.h b/gcc/m2/mc-boot/Galists.h
index bd4557b6a51..3ed524152f4 100644
--- a/gcc/m2/mc-boot/Galists.h
+++ b/gcc/m2/mc-boot/Galists.h
@@ -124,6 +124,12 @@ EXTERN void alists_foreachItemInListDo (alists_alist l, alists_performOperation
 */
 
 EXTERN alists_alist alists_duplicateList (alists_alist l);
+
+/*
+   equalList - returns TRUE if left contains the same information as right.
+*/
+
+EXTERN bool alists_equalList (alists_alist left, alists_alist right);
 #   ifdef __cplusplus
 }
 #   endif
diff --git a/gcc/m2/mc/alists.def b/gcc/m2/mc/alists.def
index 878fc88d6dc..93bc56d1e78 100644
--- a/gcc/m2/mc/alists.def
+++ b/gcc/m2/mc/alists.def
@@ -109,4 +109,11 @@ PROCEDURE foreachItemInListDo (l: alist; p: performOperation) ;
 PROCEDURE duplicateList (l: alist) : alist ;
 
 
+(*
+   equalList - returns TRUE if left contains the same information as right.
+*)
+
+PROCEDURE equalList (left, right: alist) : BOOLEAN ;
+
+
 END alists.
diff --git a/gcc/m2/mc/alists.mod b/gcc/m2/mc/alists.mod
index 048ce1f7978..5a56ec03c2b 100644
--- a/gcc/m2/mc/alists.mod
+++ b/gcc/m2/mc/alists.mod
@@ -302,4 +302,32 @@ BEGIN
 END duplicateList ;
 
 
+(*
+   equalList - returns TRUE if left contains the same information as right.
+*)
+
+PROCEDURE equalList (left, right: alist) : BOOLEAN ;
+VAR
+   leftn, rightn, i: CARDINAL ;
+BEGIN
+   leftn := noOfItemsInList (left) ;
+   rightn := noOfItemsInList (right) ;
+   IF leftn = rightn
+   THEN
+      i := 1 ;
+      WHILE i <= leftn DO
+         IF isItemInList (right, getItemFromList (left, i))
+         THEN
+            INC (i)
+         ELSE
+            RETURN FALSE
+         END
+      END
+   ELSE
+      RETURN FALSE
+   END ;
+   RETURN TRUE
+END equalList ;
+
+
 END alists.
diff --git a/gcc/m2/mc/decl.mod b/gcc/m2/mc/decl.mod
index 3d1b57fb4ae..c3ee646caaf 100644
--- a/gcc/m2/mc/decl.mod
+++ b/gcc/m2/mc/decl.mod
@@ -682,7 +682,17 @@ TYPE
                    init :  BOOLEAN ;
                 END ;
 
+       group = POINTER TO RECORD
+                             todoQ,
+                             partialQ,
+                             doneQ   : alist ;
+                             next    : group ;
+                          END ;
+
+
 VAR
+   freeGroup,
+   globalGroup   : group ;    (* The global group of all alists.  *)
    outputFile    : File ;
    lang          : language ;
    bitsperunitN,
@@ -755,9 +765,6 @@ VAR
    baseSymbols   : symbolTree ;
    outputState   : outputStates ;
    doP           : pretty ;
-   todoQ,
-   partialQ,
-   doneQ         : alist ;
    mustVisitScope,
    simplified    : BOOLEAN ;
    tempCount     : CARDINAL ;
@@ -800,6 +807,92 @@ BEGIN
 END disposeNode ;
 
 
+(*
+   newGroup -
+*)
+
+PROCEDURE newGroup (VAR g: group) ;
+BEGIN
+   IF freeGroup = NIL
+   THEN
+      NEW (g)
+   ELSE
+      g := freeGroup ;
+      freeGroup := freeGroup^.next
+   END
+END newGroup ;
+
+
+(*
+   initGroup - returns a group which with all lists initialized.
+*)
+
+PROCEDURE initGroup () : group ;
+VAR
+   g: group ;
+BEGIN
+   newGroup (g) ;
+   WITH g^ DO
+      todoQ := alists.initList () ;
+      partialQ := alists.initList () ;
+      doneQ := alists.initList () ;
+      next := NIL
+   END ;
+   RETURN g
+END initGroup ;
+
+
+(*
+   killGroup - deallocate the group and place the group record into the freeGroup list.
+*)
+
+PROCEDURE killGroup (VAR g: group) ;
+BEGIN
+   alists.killList (g^.todoQ) ;
+   alists.killList (g^.partialQ) ;
+   alists.killList (g^.doneQ) ;
+   g^.next := freeGroup ;
+   freeGroup := g ;
+END killGroup ;
+
+
+(*
+   dupGroup - If g is not NIL then destroy g.
+              Return a duplicate of GlobalGroup (not g).
+*)
+
+PROCEDURE dupGroup (g: group) : group ;
+BEGIN
+   IF g # NIL
+   THEN
+      (* Kill old group.  *)
+      killGroup (g)
+   END ;
+   newGroup (g) ;
+   WITH g^ DO
+      (* Copy all lists.  *)
+      todoQ := alists.duplicateList (globalGroup^.todoQ) ;
+      partialQ := alists.duplicateList (globalGroup^.partialQ) ;
+      doneQ := alists.duplicateList (globalGroup^.doneQ) ;
+      next := NIL
+   END ;
+   RETURN g
+END dupGroup ;
+
+
+(*
+   equalGroup - return TRUE if group left = right.
+*)
+
+PROCEDURE equalGroup (left, right: group) : BOOLEAN ;
+BEGIN
+   RETURN ((left = right) OR
+           (alists.equalList (left^.todoQ, right^.todoQ) AND
+            alists.equalList (left^.partialQ, right^.partialQ) AND
+            alists.equalList (left^.doneQ, right^.doneQ)))
+END equalGroup ;
+
+
 (*
    getDeclaredDef - returns the token number associated with the nodes declaration
                     in the definition module.
@@ -5659,14 +5752,14 @@ END doNothing ;
 
 PROCEDURE doConstC (n: node) ;
 BEGIN
-   IF NOT alists.isItemInList (doneQ, n)
+   IF NOT alists.isItemInList (globalGroup^.doneQ, n)
    THEN
       print (doP, "#   define ") ;
       doFQNameC (doP, n) ;
       setNeedSpace (doP) ;
       doExprC (doP, n^.constF.value) ;
       print (doP, '\n') ;
-      alists.includeItemIntoList (doneQ, n)
+      alists.includeItemIntoList (globalGroup^.doneQ, n)
    END
 END doConstC ;
 
@@ -8602,13 +8695,13 @@ END doPrototypeC ;
 PROCEDURE addTodo (n: node) ;
 BEGIN
    IF (n#NIL) AND
-      (NOT alists.isItemInList (partialQ, n)) AND
-      (NOT alists.isItemInList (doneQ, n))
+      (NOT alists.isItemInList (globalGroup^.partialQ, n)) AND
+      (NOT alists.isItemInList (globalGroup^.doneQ, n))
    THEN
       assert (NOT isVarient (n)) ;
       assert (NOT isVarientField (n)) ;
       assert (NOT isDef (n)) ;
-      alists.includeItemIntoList (todoQ, n)
+      alists.includeItemIntoList (globalGroup^.todoQ, n)
    END
 END addTodo ;
 
@@ -11932,7 +12025,7 @@ END allDependants ;
 
 PROCEDURE walkDependants (l: alist; n: node) : dependentState ;
 BEGIN
-   IF (n=NIL) OR alists.isItemInList (doneQ, n)
+   IF (n=NIL) OR alists.isItemInList (globalGroup^.doneQ, n)
    THEN
       RETURN completed
    ELSIF alists.isItemInList (l, n)
@@ -11954,10 +12047,10 @@ VAR
    t: node ;
 BEGIN
    t := getType (n) ;
-   IF alists.isItemInList (doneQ, t)
+   IF alists.isItemInList (globalGroup^.doneQ, t)
    THEN
       RETURN completed
-   ELSIF alists.isItemInList (partialQ, t)
+   ELSIF alists.isItemInList (globalGroup^.partialQ, t)
    THEN
       RETURN blocked
    ELSE
@@ -12030,13 +12123,13 @@ PROCEDURE dbq (n: node) ;
 BEGIN
    IF getDebugTopological ()
    THEN
-      IF alists.isItemInList (todoQ, n)
+      IF alists.isItemInList (globalGroup^.todoQ, n)
       THEN
          db ('{T', n) ; outText (doP, '}')
-      ELSIF alists.isItemInList (partialQ, n)
+      ELSIF alists.isItemInList (globalGroup^.partialQ, n)
       THEN
          db ('{P', n) ; outText (doP, '}')
-      ELSIF alists.isItemInList (doneQ, n)
+      ELSIF alists.isItemInList (globalGroup^.doneQ, n)
       THEN
          db ('{D', n) ; outText (doP, '}')
       END
@@ -12129,7 +12222,8 @@ END walkVarient ;
 
 PROCEDURE queueBlocked (n: node) ;
 BEGIN
-   IF NOT (alists.isItemInList (doneQ, n) OR alists.isItemInList (partialQ, n))
+   IF NOT (alists.isItemInList (globalGroup^.doneQ, n) OR
+           alists.isItemInList (globalGroup^.partialQ, n))
    THEN
       addTodo (n)
    END
@@ -12145,7 +12239,7 @@ VAR
    t: node ;
 BEGIN
    t := getType (n) ;
-   IF alists.isItemInList (doneQ, t)
+   IF alists.isItemInList (globalGroup^.doneQ, t)
    THEN
       RETURN completed
    ELSE
@@ -12244,7 +12338,8 @@ VAR
 BEGIN
    (* if the type of, n, is done or partial then we can output pointer.  *)
    t := getType (n) ;
-   IF alists.isItemInList (partialQ, t) OR alists.isItemInList (doneQ, t)
+   IF alists.isItemInList (globalGroup^.partialQ, t) OR
+      alists.isItemInList (globalGroup^.doneQ, t)
    THEN
       (* pointer to partial can always generate a complete type.  *)
       RETURN completed
@@ -12270,7 +12365,7 @@ BEGIN
       END ;
 *)
       (* an array can only be declared if its data type has already been emitted.  *)
-      IF NOT alists.isItemInList (doneQ, type)
+      IF NOT alists.isItemInList (globalGroup^.doneQ, type)
       THEN
          s := walkDependants (l, type) ;
          queueBlocked (type) ;
@@ -12320,7 +12415,7 @@ VAR
    t: node ;
 BEGIN
    t := getType (n) ;
-   IF alists.isItemInList (partialQ, t)
+   IF alists.isItemInList (globalGroup^.partialQ, t)
    THEN
       (* parameter can be issued from a partial.  *)
       RETURN completed
@@ -12338,7 +12433,7 @@ VAR
    t: node ;
 BEGIN
    t := getType (n) ;
-   IF alists.isItemInList (partialQ, t)
+   IF alists.isItemInList (globalGroup^.partialQ, t)
    THEN
       (* parameter can be issued from a partial.  *)
       RETURN completed
@@ -12356,7 +12451,7 @@ VAR
    t: node ;
 BEGIN
    t := getType (n) ;
-   IF alists.isItemInList (partialQ, t)
+   IF alists.isItemInList (globalGroup^.partialQ, t)
    THEN
       (* parameter can be issued from a partial.  *)
       RETURN completed
@@ -12376,11 +12471,11 @@ VAR
 BEGIN
    assert (isRecordField (n)) ;
    t := getType (n) ;
-   IF alists.isItemInList (partialQ, t)
+   IF alists.isItemInList (globalGroup^.partialQ, t)
    THEN
       dbs (partial, n) ;
       RETURN partial
-   ELSIF alists.isItemInList (doneQ, t)
+   ELSIF alists.isItemInList (globalGroup^.doneQ, t)
    THEN
       dbs (completed, n) ;
       RETURN completed
@@ -12454,7 +12549,7 @@ VAR
    t: node ;
 BEGIN
    t := getType (n) ;
-   IF alists.isItemInList (partialQ, t)
+   IF alists.isItemInList (globalGroup^.partialQ, t)
    THEN
       (* proctype can be generated from partial types.  *)
    ELSE
@@ -12787,7 +12882,7 @@ PROCEDURE tryCompleteFromPartial (n: node; t: nodeProcedure) : BOOLEAN ;
 BEGIN
    IF isType (n) AND (getType (n)#NIL) AND isPointer (getType (n)) AND (allDependants (getType (n)) = completed)
    THEN
-      (* alists.includeItemIntoList (partialQ, getType (n)) ; *)
+      (* alists.includeItemIntoList (globalGroup^.partialQ, getType (n)) ; *)
       outputHiddenComplete (n) ;
       RETURN TRUE
    ELSIF allDependants (n) = completed
@@ -13824,9 +13919,9 @@ BEGIN
    THEN
       m := Sprintf0 (InitString ('\n')) ;
       m := KillString (WriteS (StdOut, m)) ;
-      dumpQ ('todo', todoQ) ;
-      dumpQ ('partial', partialQ) ;
-      dumpQ ('done', doneQ)
+      dumpQ ('todo', globalGroup^.todoQ) ;
+      dumpQ ('partial', globalGroup^.partialQ) ;
+      dumpQ ('done', globalGroup^.doneQ)
    END
 END dumpLists ;
 
@@ -13885,7 +13980,8 @@ BEGIN
             pt (n) ;
             addTodo (q) ;
             RETURN TRUE
-         ELSIF isArray (q) AND (seenPointer OR alists.isItemInList (doneQ, getType (q)))
+         ELSIF isArray (q) AND (seenPointer OR
+                                alists.isItemInList (globalGroup^.doneQ, getType (q)))
          THEN
             pt (n) ;
             addTodo (q) ;
@@ -13997,23 +14093,23 @@ VAR
    d   : node ;
 BEGIN
    i := 1 ;
-   n := alists.noOfItemsInList (todoQ) ;
+   n := alists.noOfItemsInList (globalGroup^.todoQ) ;
    WHILE i<=n DO
-      d := alists.getItemFromList (todoQ, i) ;
+      d := alists.getItemFromList (globalGroup^.todoQ, i) ;
       IF tryComplete (d, c, t, v)
       THEN
-         alists.removeItemFromList (todoQ, d) ;
-	 alists.includeItemIntoList (doneQ, d) ;
+         alists.removeItemFromList (globalGroup^.todoQ, d) ;
+	 alists.includeItemIntoList (globalGroup^.doneQ, d) ;
          i := 1
       ELSIF tryPartial (d, pt)
       THEN
-         alists.removeItemFromList (todoQ, d) ;
-         alists.includeItemIntoList (partialQ, d) ;
+         alists.removeItemFromList (globalGroup^.todoQ, d) ;
+         alists.includeItemIntoList (globalGroup^.partialQ, d) ;
          i := 1
       ELSE
          INC (i)
       END ;
-      n := alists.noOfItemsInList (todoQ)
+      n := alists.noOfItemsInList (globalGroup^.todoQ)
    END
 END tryOutputTodo ;
 
@@ -14028,13 +14124,13 @@ VAR
    d   : node ;
 BEGIN
    i := 1 ;
-   n := alists.noOfItemsInList (partialQ) ;
+   n := alists.noOfItemsInList (globalGroup^.partialQ) ;
    WHILE i<=n DO
-      d := alists.getItemFromList (partialQ, i) ;
+      d := alists.getItemFromList (globalGroup^.partialQ, i) ;
       IF tryCompleteFromPartial (d, t)
       THEN
-         alists.removeItemFromList (partialQ, d) ;
-         alists.includeItemIntoList (doneQ, d) ;
+         alists.removeItemFromList (globalGroup^.partialQ, d) ;
+         alists.includeItemIntoList (globalGroup^.doneQ, d) ;
          i := 1 ;
          DEC (n)
       ELSE
@@ -14076,8 +14172,8 @@ PROCEDURE debugLists ;
 BEGIN
    IF getDebugTopological ()
    THEN
-      debugList ('todo', todoQ) ;
-      debugList ('partial', partialQ)
+      debugList ('todo', globalGroup^.todoQ) ;
+      debugList ('partial', globalGroup^.partialQ)
    END
 END debugLists ;
 
@@ -14107,44 +14203,39 @@ VAR
    i, h: CARDINAL ;
    l   : alist ;
 BEGIN
-   h := alists.noOfItemsInList (todoQ) ;
+   h := alists.noOfItemsInList (globalGroup^.todoQ) ;
    i := 1 ;
    WHILE i <= h DO
-      n := alists.getItemFromList (todoQ, i) ;
+      n := alists.getItemFromList (globalGroup^.todoQ, i) ;
       l := alists.initList () ;
       visitNode (l, n, p) ;
       alists.killList (l) ;
-      h := alists.noOfItemsInList (todoQ) ;
+      h := alists.noOfItemsInList (globalGroup^.todoQ) ;
       INC (i)
    END
 END populateTodo ;
 
 
 (*
-   topologicallyOut -
+   topologicallyOut - keep trying to resolve the todoQ and partialQ
+                      until there is no change from the global group.
 *)
 
 PROCEDURE topologicallyOut (c, t, v, tp,
                             pc, pt, pv: nodeProcedure) ;
 VAR
-   tol, pal,
-   to,  pa : CARDINAL ;
+   before: group ;
 BEGIN
    populateTodo (addEnumConst) ;
-   tol := 0 ;
-   pal := 0 ;
-   to := alists.noOfItemsInList (todoQ) ;
-   pa := alists.noOfItemsInList (partialQ) ;
-   WHILE (tol#to) OR (pal#pa) DO
+   before := NIL ;
+   REPEAT
+      before := dupGroup (before) ;  (* Get a copy of the globalGroup and free before.  *)
       dumpLists ;
       tryOutputTodo (c, t, v, tp) ;
       dumpLists ;
-      tryOutputPartial (pt) ;
-      tol := to ;
-      pal := pa ;
-      to := alists.noOfItemsInList (todoQ) ;
-      pa := alists.noOfItemsInList (partialQ)
-   END ;
+      tryOutputPartial (pt)
+   UNTIL equalGroup (before, globalGroup) ;
+   killGroup (before) ;
    dumpLists ;
    debugLists
 END topologicallyOut ;
@@ -15352,7 +15443,7 @@ END setLangM2 ;
 
 PROCEDURE addDone (n: node) ;
 BEGIN
-   alists.includeItemIntoList (doneQ, n)
+   alists.includeItemIntoList (globalGroup^.doneQ, n)
 END addDone ;
 
 
@@ -15368,7 +15459,7 @@ BEGIN
       addDone (n) ;
       RETURN
    END ;
-   IF (NOT isDef (n)) AND (lookupImp (getSymName (getScope (n))) = getMainModule ())
+   IF FALSE AND (lookupImp (getSymName (getScope (n))) = getMainModule ())
    THEN
       metaError1 ('cyclic dependancy found between another module using {%1ad} from the definition module of the implementation main being compiled, use the --extended-opaque option to compile', n) ;
       flushErrors ;
@@ -16977,9 +17068,8 @@ BEGIN
    lang := ansiC ;
    outputFile := StdOut ;
    doP := initPretty (write, writeln) ;
-   todoQ := alists.initList () ;
-   partialQ := alists.initList () ;
-   doneQ := alists.initList () ;
+   freeGroup := NIL ;
+   globalGroup := initGroup () ;
    modUniverse := initTree () ;
    defUniverse := initTree () ;
    modUniverseI := InitIndex (1) ;

